crashpad::MinidumpSimpleStringDictionaryEntryWriter Class Referencefinal

The writer for a MinidumpSimpleStringDictionaryEntry object in a minidump file. More...

`#include "minidump/minidump_simple_string_dictionary_writer.h"`

Inheritance diagram for crashpad::MinidumpSimpleStringDictionaryEntryWriter:

## Public Member Functions

const MinidumpSimpleStringDictionaryEntry * | GetMinidumpSimpleStringDictionaryEntry () const
| Returns a MinidumpSimpleStringDictionaryEntry referencing this object’s data. More...
void | SetKeyValue (const std::string &key, const std::string &value)
| Sets the strings to be written as the entry object’s key and value. More...
const std::string & | Key () const
| Retrieves the key to be written. More...
Public Member Functions inherited from crashpad::internal::MinidumpWritable
virtual bool | WriteEverything (FileWriterInterface *file_writer)
| Writes an object and all of its children to a minidump file. More...
void | RegisterRVA (RVA *rva)
| Registers a file offset pointer as one that should point to the object on which this method is called. More...
void | RegisterLocationDescriptor (MINIDUMP_LOCATION_DESCRIPTOR *location_descriptor)
| Registers a location descriptor as one that should point to the object on which this method is called. More...

## Protected Member Functions

bool | Freeze () override
| Transitions the object from kStateMutable to kStateFrozen. More...
size_t | SizeOfObject () override
| Returns the amount of space that this object will consume when written to a minidump file, in bytes, not including any leading or trailing padding necessary to maintain proper alignment. More...
std::vector< MinidumpWritable * > | Children () override
| Returns the object’s children. More...
bool | WriteObject (FileWriterInterface *file_writer) override
| Writes the object’s content. More...
Protected Member Functions inherited from crashpad::internal::MinidumpWritable
State | state () const
| The state of the object.
virtual size_t | Alignment ()
| Returns the object’s desired byte-boundary alignment. More...
virtual Phase | WritePhase ()
| Returns the object’s desired write phase. More...
size_t | WillWriteAtOffset (Phase phase, FileOffset *offset, std::vector< MinidumpWritable *> *write_sequence)
| Prepares the object to be written at a known file offset, transitioning it from kStateFrozen to kStateWritable. More...
virtual bool | WillWriteAtOffsetImpl (FileOffset offset)
| Called once an object’s writable file offset is determined, as it transitions into kStateWritable. More...
bool | WritePaddingAndObject (FileWriterInterface *file_writer)
| Writes the object, transitioning it from kStateWritable to kStateWritten. More...

## Additional Inherited Members

Protected Types inherited from crashpad::internal::MinidumpWritable
enum | State
| Identifies the state of an object. More...
enum | Phase
| Identifies the phase during which an object will be written to a minidump file. More...
Static Protected Attributes inherited from crashpad::internal::MinidumpWritable
static constexpr size_t | kInvalidSize = std::numeric_limits<size_t>::max()
| A size value used to signal failure by methods that return `size_t`.

## Detailed Description

The writer for a MinidumpSimpleStringDictionaryEntry object in a minidump file.

Because MinidumpSimpleStringDictionaryEntry objects only appear as elements of MinidumpSimpleStringDictionary objects, this class does not write any data on its own. It makes its MinidumpSimpleStringDictionaryEntry data available to its MinidumpSimpleStringDictionaryWriter parent, which writes it as part of a MinidumpSimpleStringDictionary.

## Member Function Documentation

## Children()

std::vector< internal::MinidumpWritable * > crashpad::MinidumpSimpleStringDictionaryEntryWriter::Children | ( |  | ) |

overrideprotectedvirtual

Returns the object’s children.

Note
  Valid in kStateFrozen or any subsequent state.

Reimplemented from crashpad::internal::MinidumpWritable.

## Freeze()

bool crashpad::MinidumpSimpleStringDictionaryEntryWriter::Freeze | ( |  | ) |

overrideprotectedvirtual

Transitions the object from kStateMutable to kStateFrozen.

The default implementation marks the object as frozen and recursively calls Freeze() on all of its children. Subclasses may override this method to perform processing that should only be done once callers have finished populating an object with data. Typically, a subclass implementation would call RegisterRVA() or RegisterLocationDescriptor() on other objects as appropriate, because at the time Freeze() runs, the in-memory locations of RVAs and location descriptors are known and will not change for the remaining duration of an object’s lifetime.

Returns
  `true` on success. `false` on failure, with an appropriate message logged.

Reimplemented from crashpad::internal::MinidumpWritable.

## GetMinidumpSimpleStringDictionaryEntry()

const MinidumpSimpleStringDictionaryEntry * crashpad::MinidumpSimpleStringDictionaryEntryWriter::GetMinidumpSimpleStringDictionaryEntry | ( |  | ) | const

Returns a MinidumpSimpleStringDictionaryEntry referencing this object’s data.

This method is expected to be called by a MinidumpSimpleStringDictionaryWriter in order to obtain a MinidumpSimpleStringDictionaryEntry to include in its list.

Note
  Valid in kStateWritable.

## Key()

const std::string& crashpad::MinidumpSimpleStringDictionaryEntryWriter::Key | ( |  | ) | const

inline

Retrieves the key to be written.

Note
  Valid in any state.

## SetKeyValue()

void crashpad::MinidumpSimpleStringDictionaryEntryWriter::SetKeyValue | ( | const std::string & | key,
|  | const std::string & | value
| ) |  |

Sets the strings to be written as the entry object’s key and value.

Note
  Valid in kStateMutable.

## SizeOfObject()

size_t crashpad::MinidumpSimpleStringDictionaryEntryWriter::SizeOfObject | ( |  | ) |

overrideprotectedvirtual

Returns the amount of space that this object will consume when written to a minidump file, in bytes, not including any leading or trailing padding necessary to maintain proper alignment.

Note
  Valid in kStateFrozen or any subsequent state.

Implements crashpad::internal::MinidumpWritable.

## WriteObject()

bool crashpad::MinidumpSimpleStringDictionaryEntryWriter::WriteObject | ( | FileWriterInterface * | file_writer | ) |

overrideprotectedvirtual

Writes the object’s content.

Parameters

  [in] | file_writer | The file writer to receive the object’s content.

Returns
  `true` on success. `false` on error, indicating that the content could not be written to the minidump file.

Note
  Valid in kStateWritable. The object will transition to kStateWritten after this method returns.

Implements crashpad::internal::MinidumpWritable.

The documentation for this class was generated from the following files:

- minidump/minidump_simple_string_dictionary_writer.h
- minidump/minidump_simple_string_dictionary_writer.cc